﻿# ##########################################################################
# Programme Python permettant de tester la 1ère loi de Kepler en terminale S
# ##########################################################################
# O. CHAUMETTE - Lycée JP SARTRE - 69500 BRON - olivier.chaumette@ac-lyon.fr
# ##########################################################################


# ##########################
# IMPORTATION DES MODULES #
# #########################
import numpy as np
import matplotlib.pyplot as plt
import csv

# ###############################################
# FONCTIONS
# ###############################################
# Fonction qui récupère des données du fichier txt issu de https://ssp.imcce.fr/forms/ephemeris
# date (optionnelle), teta et r. Voir détails plus loin
def charge_Donnees(Nom_fichier):
    date_=np.array([])
    teta_deg_=np.array([])
    r_=np.array([])
    Fichier_Csv = open(Nom_fichier, 'r')
    Objet_Reader_Csv=csv.reader(Fichier_Csv,delimiter = ';')   # on créée un objet csv, le délimiteur étant ";"
    num_ligne=1                                                 # variable contenant le n° deligne
    for Ligne in Objet_Reader_Csv:                              # on parcourt chaque ligne du fichier tabulé (chaque ligne est une liste)
        if num_ligne>1:                 # si ligne avec des "vraies" données (donc au delà de la 1ère ligne dans le fichier csv)
            date_=np.append(date_,Ligne[0])        # on ajoute la date au tableau date (colonne 0 du CSV)
            teta_deg_=np.append(teta_deg_,float(Ligne[1]))    # on ajoute à la liste "teta" la valeur de la teta en décimal (colonne 1 du CSV)
            r_=np.append(r_,float(Ligne[3]))              # on ajoute la distance planète-soleil en ua à la liste "r"
        else:
            num_ligne+=1                    # incrémentation de ligne (jusqu'à ce qu'on trouve des vraies données ligne 1
    Fichier_Csv.close()
    return date_,teta_deg_,r_

# remarque pour obtenir le fichier CSV:
# https://ssp.imcce.fr/forms/ephemeris
# Paramètres à choisir :
    # Corps : choisir une planète
    # Epoque : choisir date de départ, intervalle, nombre de dates.
    # Centre du repère : choisir "heliocentre"
    # Plan de référence : choisir "ecliptique" et les coordonnées "spheriques". Laisser J2000
# lancer le calcul. Puis cliquer sur exporter en CSV (flèche à droite des données)
# choisir CSV puis 3décimal" pour les angmles (évite la conversion) et dates: ISO
# ################ FIN DES FONCTIONS ###########################


###------------------------------------------
### Début du programme
###------------------------------------------
# initialisation des tableaux numpy
date=np.array([])           # date (pas forcément utile)
teta_deg=np.array([])      # teta en coordonnées "héliocentriques"
                            # les planètes étant quasiment dans le plan de l'écliptique,
                            # on ne récupèrera pas la latitude héliocentrique
r=np.array([])              # distance au Soleil en ua

planete="Mercure"
# nom du fichier csv
Nom_fichier="Mercure2019.csv"

# appel de la fonction pour récupérer les données dans 3 tableaux
date,teta_deg,r = charge_Donnees(Nom_fichier)



""" Début du travail des élèves
----------------------------------- """
# Calcul de teta en radian à partir de teta_deg (valeur en degré):
teta=


# coordonnées cartésiennes en fonction de r et teta:
x=
y=

# affichage de y en fonction de x en rouge (r) et sous forme de croix (x):


""" Fin du travail des élèves
----------------------------------- """


# affichage du soleil
plt.plot(0,0,"ko")
plt.text(0.01,0.01,"Soleil")
plt.title("Positions de la planète "+planete+"\ndans le référentiel héliocentrique")
# repère orthonormé
axes=plt.gca()
axes.set_aspect('equal','box')
# amélioration de l'affichage
# on enlève toutes les graduations (label et tick) des axes
axes.set_yticklabels([])
axes.set_xticklabels([])
axes.xaxis.set_ticks([])
axes.yaxis.set_ticks([])
# affichage des legende à droite du cadre
plt.legend(bbox_to_anchor=(1.05, 1),loc='upper left',borderaxespad=0.)
# affichage de la figure bien adapté à la fenêtre la fenêtre
plt. tight_layout()
plt.show()