﻿# PROGRAMME TERMINALE SPECIALITE 2021
# -----------------------------------
# code proposé par Olivier CHAUMETTE - Lycée JPS Sartre - 69600 BRON - olivier.chaumette@ac-lyon.fr
# -------------------------------------------------
# Exploiter, à l’aide d’un langage de programmation, des données astronomiques ou satellitaires
# pour tester les deuxième et troisième lois de Kepler.
# ----------------------------------------------------------------------
# Programme Python permettant de tester la 3ème loi de Kepler
# VERSION GRAPHIQUE
# -----------------------------------------------------------

# ##########################
# IMPORTATION DES MODULES #
# #########################
import numpy as np
import matplotlib.pyplot as plt

# nom de la planète (inutile à priori)
planete=np.array(["Mercure","Venus","Terre","Mars","Jupiter","Saturne","Uranus","Neptune"])
# données issues de: https://fr.wikiversity.org/wiki/Système_solaire/Fiche/Caractéristiques_des_planètes_de_notre_système_solaire

""" début du travail des élèves """
# Période de révolution en années
T=np.array([0.24,0.615,1,1.88,11.86,29.46,84,164.79])
# distance moyenne au Soleil en millions de km
R=np.array([57.8,108.2,149.6,227.9,778.6,1433.5,2872.5,4495.1])

""" TRAVAIL 1: Transformer T et R dans les unités du système international """
un_an=365.25*24*3600
T=T*un_an
R=R*1e9

""" TRAVAIL 2:
    - Représenter T au carré en fonction de R au cube (croix rouges) à partir des données expérimentales avec une légende
    - Nommer les axes et donner un titre au graphique """
# les labels sont au format LateX. A donner aux élèves ou bien écrire R^3
plt.plot(R**3,T**2,"rx",label="Données astronomiques: T ² = f("+r"$R^3$"+")")

plt.title("Test de la 3ème loi de Kepler")
plt.xlabel("Distance moyenne au soleil au cube: "+r"$R^3$ en $m^3$")
plt.ylabel("Période de révolution : T² en s²")

""" TRAVAIL 3
    Montrer que le coefficient directeur de la courbe précédente est 4pi²/GM """

# calcul de 4pi²/GM
G=6.67e-11
Ms=2.0e30
K=4*(np.pi**2)/(G*Ms)
# tracé de K.R^3 en fonction de R^3
# les labels sont au format LateX. A donner aux élèves ou bien écrire R^3
plt.plot(R**3,K*(R**3),"b-",label="T ²="+r"$\frac{4\pi ²}{G.M_s}.R^3$")


""" Fin du travail des élèves """
plt.legend() # affichage des légendes
plt.grid()   # grille
plt.show()