﻿# PROGRAMME TERMINALE SPECIALITE 2021
# -----------------------------------
# code proposé par Olivier CHAUMETTE - Lycée JPS Sartre - 69600 BRON - olivier.chaumette@ac-lyon.fr
# -------------------------------------------------
# Exploiter, à l’aide d’un langage de programmation, des données astronomiques ou satellitaires
# pour tester les deuxième et troisième lois de Kepler.
# ----------------------------------------------------------------------
# Programme Python permettant de tester la 3ème loi de Kepler
# VERSION SANS GRAPHIQUE
# -----------------------------------------------------------

# ##########################
# IMPORTATION DES MODULES #
# #########################
import numpy as np
# import matplotlib.pyplot as plt           # pas besoin de matplotlib

# nom de la planète
planete=np.array(["Mercure","Venus","Terre","Mars","Jupiter","Saturne","Uranus","Neptune"])
# données issues de: https://fr.wikiversity.org/wiki/Système_solaire/Fiche/Caractéristiques_des_planètes_de_notre_système_solaire

""" début du travail des élèves """
# Période de révolution en années
T=np.array([0.24,0.615,1,1.88,11.86,29.46,84,164.79])
# distance moyenne au Soleil en millions de km
R=np.array([57.8,108.2,149.6,227.9,778.6,1433.5,2872.5,4495.1])

""" TRAVAIL 1: Transformer T et R dans les unités du système international """
un_an=365.25*24*3600
T=T*un_an
R=R*1e9

""" TRAVAIL 2:
    - Montrer que T au carré sur R au cube vaut 4pi²/GM pour chaque planète
    - Réaliser un affichage correct """
# calcul de 4pi²/GM
G=6.67e-11
Ms=2.0e30
K=4*(np.pi**2)/(G*Ms)

# Calcul de T au carré sur R au cube: (on créé ainsi un nouveau tableau numpy)
T2_sur_R3=T**2/R**3

# affichage avec mise en forme
NP=len(planete)
for i in range(0,NP):
    print("Pour la planète", planete[i],"T²/R^3=",T2_sur_R3[i],"s².m^-3")
print("4pi²/GM =",K, "s².m^-3")

""" Fin du travail des élèves """
